#![warn(clippy::pedantic)]
#![warn(clippy::nursery)]
#![allow(clippy::cast_possible_truncation)]
#![allow(clippy::cast_precision_loss)]
#![allow(clippy::items_after_statements)]
#![allow(clippy::many_single_char_names)]
#![allow(clippy::module_name_repetitions)]
mod bytes;
mod bytes_base64;
mod cbc;
mod ctr;
mod dh;
mod dsa;
mod ecb;
mod md4;
mod mt19937;
mod mtcipher;
mod parser;
mod rsa;
mod set1;
mod set2;
mod set3;
mod set4;
mod set5;
mod set6;
mod sha1;
mod srp;
mod utils;

fn main() {
    const RUN_ALL: bool = true;
    if RUN_ALL {
        set1::challenge1();
        set1::challenge2();
        set1::challenge3();
        set1::challenge4();
        set1::challenge5();
        set1::challenge6();
        set1::challenge7();
        set1::challenge8();
        set2::challenge9();
        set2::challenge10();
        set2::challenge11();
        set2::challenge12();
        set2::challenge13();
        set2::challenge14();
        set2::challenge15();
        set2::challenge16();
        set3::challenge17();
        set3::challenge18();
        set3::challenge19();
        set3::challenge20();
        set3::challenge21();
        set3::challenge22();
        set3::challenge23();
        set3::challenge24();
        set4::challenge25();
        set4::challenge26();
        set4::challenge27();
        set4::challenge28();
        set4::challenge29();
        set4::challenge30();
        set4::challenge31();
        set4::challenge32();
        set5::challenge33();
        set5::challenge34();
        set5::challenge35();
        set5::challenge36().unwrap_or_else(|| println!("[fail] challenge 36"));
        set5::challenge37().unwrap_or_else(|| println!("[fail] challenge 37"));
        set5::challenge38().unwrap_or_else(|| println!("[fail] challenge 38"));
        set5::challenge39().unwrap_or_else(|| println!("[fail] challenge 39"));
        set5::challenge40().unwrap_or_else(|| println!("[fail] challenge 40"));
        set6::challenge41().unwrap_or_else(|_| println!("[fail] challenge 41"));
        set6::challenge42().unwrap_or_else(|_| println!("[fail] challenge 42"));
        set6::challenge43().unwrap_or_else(|| println!("[fail] challenge 43"));
        set6::challenge44().unwrap_or_else(|| println!("[fail] challenge 44"));
        set6::challenge45().unwrap_or_else(|| println!("[fail] challenge 45"));
        set6::challenge46().unwrap_or_else(|_| println!("[fail] challenge 46"));
        set6::challenge47().unwrap_or_else(|_| println!("[fail] challenge 47"));
        set6::challenge48().unwrap_or_else(|_| println!("[fail] challenge 48"));
    }
}
